 
C   (0,1) * (0,1) is divided into procx * procy subdomains 
C   numbered row by row,
C   according to myid, the coordinates of the lower left corner
C   (xl,yb) and the upper right corner (xr,yt) are generated
C
C	IN:  	myid	  process id
C		procx	  number of subdomains in x-direction
C		procy	  number of subdomains in x-direction
C	OUT:    (xl,yb)   coordinates of the lower left corner
C		(xr,yt)   coordinates the upper right corner



	SUBROUTINE IniCoord(myid,procx,procy,xl,xr,yb,yt)

	IMPLICIT NONE
	DOUBLE PRECISION xl,xr,yb,yt,hx,hy
	INTEGER myid,procx,procy,kx,ky
	
	kx = MOD(myid,procx)			! column
	ky = myid/procx				! row
	hx = 1D0/procx
	hy = 1D0/procy
C					subdomain - part of unit square
	xl = kx*hx				!  left
	xr = (kx+1)*hx				!  right
	yb = ky*hy				!  bottom
	yt = (ky+1)*hy				!  top
	
	RETURN
	END

