#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

int main(argc,argv)
int argc;
char *argv[];
{
  int   nx, ny, nnx, nny, *id, *ik, nnode, sksize, ScaleUp,
    i, zero, procx, procy, numprocs, myid, neigh[4], color, ierr;
  double xl, xr, yb, yt, *sk, dzero=0., *u, *f, omega,  done = 1.;

  myid     = 0;
  numprocs = 1;

  if (myid == 0)
  {
     printf("\n There are %d processes running.\n \n",numprocs);
  }

  procx = (int) sqrt((double) numprocs);
  procy = (int) sqrt((double) numprocs);

  if (procy * procx != numprocs) 
  {
    printf("\n Wrong number of processors !\n \n");
  }
  else
  {
    IniGeom(myid, procx, procy, neigh, &color);

    /*                                              subdomain coordinates */
    IniCoord(myid, procx, procy, &xl, &xr, &yb, &yt);

    nx = 10;
    ny = 10;

    /* number of nodes per direction (xl,xr)=nx+1=:nex, (yb,yt)=ny+1=:ney */
    nnx = nx + 1;
    nny = ny + 1;
    /* number of degrees of freedom  */
    nnode = nnx*nny;

    /* allocate memory */
    u = (double *) malloc(nnode*sizeof(dzero));		/* temperature       */
    f = (double *) malloc(nnode*sizeof(dzero));		/* r.h.s.            */

    sksize = 4*nx*ny+2*(nx+ny)+1;			/* symm. storage     */
    sk = (double *) malloc(sksize*sizeof(dzero));	/* K                 */
    ik = (int *) malloc(sksize*sizeof(zero));		/* crs pointer for K */
    id = (int *) malloc(nnode*sizeof(zero));		/* crs pointer for K */

    /* matrix, rhs generation including Dirichlet B.C. */

    GetMatrix(nx, ny, xl, xr, yb, yt, sk, id, ik, f);	/* generate K, rhs   */

    SetU(nx, ny, u);			     /* set solution/boundary values */
    ApplyDirichletBC(nx, ny, neigh, u, sk, id, ik, f); /* apply B.C.       */

    JacobiSolve(nx, ny, sk, id, ik, f, u );

    SaveVector("t.dat",u, nx, ny, xl, xr, yb, yt, &ierr);

    free(id); free(ik); free(sk); free(f); free(u);
  }	       
  return 0;
}

            
