#include <math.h>
#include <stdio.h>

/*  initial guess u and diagonal are INPUT */

void JacobiSolve2(nx, ny, sk, id, ik, f, u, dd, aux )
int    nx,ny,*id,*ik;
double *sk, *f, *u, *dd, *aux;
{
  extern double dscapr();
  double *r, dzero=0, sigma, sigma0, tol, tol2, omega;
  int nnode, iter, maxiter;
 
  omega   = 1.0;
  maxiter = 100;
  tol  = 1e-5;						/* tolerance   */
  tol2 = tol*tol;					/* tolerance^2 */
  
  nnode = (nx+1)*(ny+1);
  r = aux;

  /*  Initial sweep  */
  vdcopy(nnode, r, 1, f, 1);			/*                 */
  CrsMult(0, nnode-1, r, u, id, ik, sk, -1.0);	/*  r := f - K*u   */
  
  vddiv(nnode, r, 1, r, 1, dd, 1);		/*  r := D^{-1}*r  */
  sigma0 = dscapr(nnode,r,r);			/* s0 := <r,r>     */   
  
  /* Iteration sweeps */
  iter  = 0;
  sigma = sigma0;
  while ( sigma > tol2*sigma0 && maxiter>iter)
  {
    iter++;
    vdaxpy(nnode, u, u, omega, r );		/*  u := u + om*r  */  
    vdcopy(nnode, r, 1, f, 1);			/*                 */
    CrsMult(0, nnode-1, r, u, id, ik, sk, -1.0);/*  r := f - K*u   */

    vddiv(nnode, r, 1, r, 1, dd, 1);		/*  r := D^{-1}*r  */ 
    sigma = dscapr(nnode,r,r);			/* s0 := <r,r>     */
    
/*    		printf("Iteration %u : %g\n",iter,sqrt(sigma/sigma0));   */ 
  } 

/*  		printf("%u Iterations\n",iter); */
  
  return;
}
