#include <math.h>
#include <stdio.h>
#include "mg.h"

int main(argc,argv)
int argc;
char *argv[];
{
  int   nx, ny, nnx, nny, *id, *ik, nnode, sksize, ScaleUp,
    i, zero, procx, procy,  NXglob, NYglob,
    neigh[4], nlevels, ierr;
  double xl, xr, yb, yt, *sk, dzero=0., *u, *f, 
    omega,  done = 1.;
  ControlStruct control;
  PointerStruct pointers;
 
 /*	set whole bondary to homogeneous Dirichlet B.C. */
  neigh[0] = neigh[1] = neigh[2] = neigh[3] = -1;
  procx=procy=1;
       /*                                              subdomain coordinates */
  IniCoord(0, 1, 1, &xl, &xr, &yb, &yt);

  nlevels = 5; 				/* set number of mg levels */

  ScaleUp = -1;
  /* number of local intervals on (xl,xr)=:nx, (yb,yt)=:ny */
  if (ScaleUp==1)
  {
  /*		for scale up evaluation   */ 
    			printf("scale up evaluation\n");
    nx = 2;
    ny = 2;
    NXglob = nx*procx;
    NYglob = ny*procy;
  }
  else
  {
  /*		for speed up evaluation   */ 
    			printf("speed up evaluation\n");
    NXglob = NYglob = 8; 
    nx = NXglob/procx;
    ny = NYglob/procy;
  }

  /* Set mg control parameters */
  control.cycle = 1;		/* V-cycle			*/
  control.npre  = 1;		/* #sweeps in presmoothing	*/
  control.npost = 1;		/* #sweeps in postsmoothing	*/

  AllocLevels(nlevels, nx, ny, &pointers, &ierr);
  if (ierr!=0) printf("\nError No. %i in AllocLevels.\n",ierr);

  IniLevels(xl, xr, yb, yt, nlevels, neigh, &pointers, &ierr); 

  MGMSolver(&pointers, &control, nlevels-1, neigh); 
  
  SaveVector("t.dat",pointers.u[nlevels-1], pointers.nx[nlevels-1], 
  		pointers.ny[nlevels-1],xl, xr, yb, yt, &ierr);

    			printf("-----------\n"); 
  FreeLevels(nlevels, &pointers, &ierr); 
/* 			printf("###########\n"); */
     
  			printf("End of program\n");
 return 0;
}

            
