#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "mpi.h"

int main(argc,argv)
int argc;
char *argv[];
{
    int i,myid, numprocs; 
    MPI_Comm icomm;
    
    int nin, nout, maxbuf = 100, yourid;
    double *x,*y, one=1.;
    
    MPI_Init(&argc,&argv);
    
    icomm = MPI_COMM_WORLD;
    
    MPI_Comm_size(icomm,&numprocs);
    MPI_Comm_rank(icomm,&myid);

    if (myid == 0)
    {
       printf("\n There are %d processes running.\n \n",numprocs);
    }

    if (myid == 0) printf("\n");
    
    x = (double*)malloc(sizeof(double)*maxbuf);
    y = (double*)malloc(sizeof(double)*maxbuf);

    yourid = myid ^ 1;
    nin    = 20;
    one = (double)myid*10+5;
    memcpy(x,&one,sizeof(double)*nin);
    
    ExchangeD(yourid,nin,x,&nout,y,maxbuf,icomm); 

    for(i=1; i<=nout; i++)
	{
	printf("\n %d %d : %d %e\n",i,myid,nout,y[0]);
	}

    free(y); free(x);
    MPI_Finalize();
}

            
