/*				master process			*/
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "mpi.h"

int main(argc,argv)
int argc;
char *argv[];
{
    int i, myid, numprocs, info, flag, numspawn, num_slaves, all_num, all_myid; 
    int *errcodes;
    MPI_Comm master, slaves, all_nodes;
/*
    printf("\n argc: %d  \n",argc);
    printf("\n %s   %s   %s  \n",argv[0],argv[1],argv[2]);
*/    
    if (argc <= 2)
    {
      printf("\n Command line:  %s  number_of_slaves  slave_prog \n\n",argv[0]);
      exit(-1);
    }

    MPI_Init(&argc,&argv); 
    MPI_Comm_get_parent(&master);       
    if (master==MPI_COMM_NULL) master = MPI_COMM_SELF;
    MPI_Comm_rank(master,&myid);
      
/*    MPI_Attr_get(MPI_COMM_WORLD, MPI_UNIVERSE_SIZE,&univ_size,&flag);
    printf("univ-size: %d   flag : %d\n",univ_size,flag); */

/*	Spawn the slaves						*/

    numspawn = atoi(argv[1]);
    errcodes = (int*)malloc(numspawn*sizeof(int)); 
    info = MPI_Comm_spawn(argv[2], MPI_ARGV_NULL, numspawn, 
	 		    MPI_INFO_NULL, 0, 
	 		    master, &slaves, errcodes );

/*	How many slaves are started?					*/

    MPI_Comm_remote_size(slaves,&num_slaves);
    printf("\nMaster has started  %d  slaves.\n",num_slaves);
  
    for (i = 0; i < numslaves; i++)
    {
      if (errcodes[i] != MPI_SUCCESS)
      	printf("Slave  %d  with error  %d  .\n",i,errcodes[i]);
    }

/*	Check master group						*/
    MPI_Comm_size(master,&numprocs);
    MPI_Comm_rank(master,&myid);
    printf("\n nr. %d  out of %d masters \n",myid,numprocs);

/* 	Create one communication group for master and slaves.		*/
/*	master = 0,  slaves = 1..numspawn				*/
   
    MPI_Intercomm_merge(slaves, 1==0, &all_nodes);
    MPI_Comm_size(all_nodes,&all_num);
    MPI_Comm_rank(all_nodes,&all_myid);
    if (all_myid==0) printf("master: %d procs in all_nodes\n",all_num);
    printf("All %d  out of %d  \n",all_myid,all_num);

/* 	Greetings from all nodes					*/

/*    greetings(all_myid,all_num,all_nodes);  */

    calc(all_myid,all_num,all_nodes); 
   
    MPI_Finalize();

    free(errcodes);
}

            
