#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mpi.h"

void My_MPI_Init(argc,argv,all_nodes)
int      argc;
char     *argv[];
MPI_Comm *all_nodes;
{
  int  i, myid, numprocs, info, numspawn, num_slaves, all_num, all_myid; 
  int  *errcodes, IsMaster;
  char ss[10];
  MPI_Comm master, slaves, othercomm;
  
  MPI_Init(&argc,&argv);
  MPI_Comm_get_parent(&master); 
  IsMaster = (master==MPI_COMM_NULL);
  if (IsMaster) 
   {					/*  master			*/
     if (argc <= 1)
      {
	printf("\n Command line:  %s  number_of_slaves  \n\n",argv[0]);
	MPI_Finalize(); exit(-1);
      }
/*	Spawn the slaves						*/

     master   = MPI_COMM_SELF;
     numspawn = atoi(argv[1]);
     errcodes = (int*)malloc(numspawn*sizeof(int));
     info     = MPI_Comm_spawn(argv[0], NULL, numspawn, 
	 		       MPI_INFO_NULL, 0, 
	 		       master, &slaves, errcodes );
     if (info) printf("Error in spawn\n");
     othercomm = slaves;
     strcpy(ss,"Master");

/*	How many slaves were started?					*/

     MPI_Comm_remote_size(slaves,&num_slaves);
     printf("\nMaster has started  %d  slaves.\n",num_slaves);
     for (i = 0; i < numspawn; i++)
     {
       if (errcodes[i] != MPI_SUCCESS)
      	 printf("Slave  %d  with error  %d  .\n",i,errcodes[i]);
     }
/*	Check master group						*/
     MPI_Comm_size(master,&numprocs);
     MPI_Comm_rank(master,&myid);
   }       
  else
   {					/*  slaves			*/
     slaves    = MPI_COMM_WORLD;
     othercomm = master;
     strcpy(ss,"Slave");

/*	How many slaves were started?  Which one I am ?			*/
        
     MPI_Comm_size(slaves,&numprocs);
     MPI_Comm_rank(slaves,&myid);
/*     printf("Slave %d  out of %d  \n",myid,numprocs);   		*/  
   }
  
  MPI_Intercomm_merge(othercomm, !IsMaster, all_nodes);
  MPI_Comm_size(*all_nodes,&all_num);
  MPI_Comm_rank(*all_nodes,&all_myid);
  printf("%s : %d  out of %d  \n",ss,all_myid,all_num);
  
  fflush(stdout); 
  MPI_Barrier(*all_nodes);
}
